package com.dhcc.finance.main.domain;

import java.util.ArrayList;
import java.util.List;

public class CwBdScenariofieldExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CwBdScenariofieldExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("ID is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("ID is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("ID =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("ID <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("ID >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("ID >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("ID <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("ID <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("ID like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("ID not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("ID in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("ID not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("ID between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("ID not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andFlowTypeIsNull() {
            addCriterion("FLOW_TYPE is null");
            return (Criteria) this;
        }

        public Criteria andFlowTypeIsNotNull() {
            addCriterion("FLOW_TYPE is not null");
            return (Criteria) this;
        }

        public Criteria andFlowTypeEqualTo(String value) {
            addCriterion("FLOW_TYPE =", value, "flowType");
            return (Criteria) this;
        }

        public Criteria andFlowTypeNotEqualTo(String value) {
            addCriterion("FLOW_TYPE <>", value, "flowType");
            return (Criteria) this;
        }

        public Criteria andFlowTypeGreaterThan(String value) {
            addCriterion("FLOW_TYPE >", value, "flowType");
            return (Criteria) this;
        }

        public Criteria andFlowTypeGreaterThanOrEqualTo(String value) {
            addCriterion("FLOW_TYPE >=", value, "flowType");
            return (Criteria) this;
        }

        public Criteria andFlowTypeLessThan(String value) {
            addCriterion("FLOW_TYPE <", value, "flowType");
            return (Criteria) this;
        }

        public Criteria andFlowTypeLessThanOrEqualTo(String value) {
            addCriterion("FLOW_TYPE <=", value, "flowType");
            return (Criteria) this;
        }

        public Criteria andFlowTypeLike(String value) {
            addCriterion("FLOW_TYPE like", value, "flowType");
            return (Criteria) this;
        }

        public Criteria andFlowTypeNotLike(String value) {
            addCriterion("FLOW_TYPE not like", value, "flowType");
            return (Criteria) this;
        }

        public Criteria andFlowTypeIn(List<String> values) {
            addCriterion("FLOW_TYPE in", values, "flowType");
            return (Criteria) this;
        }

        public Criteria andFlowTypeNotIn(List<String> values) {
            addCriterion("FLOW_TYPE not in", values, "flowType");
            return (Criteria) this;
        }

        public Criteria andFlowTypeBetween(String value1, String value2) {
            addCriterion("FLOW_TYPE between", value1, value2, "flowType");
            return (Criteria) this;
        }

        public Criteria andFlowTypeNotBetween(String value1, String value2) {
            addCriterion("FLOW_TYPE not between", value1, value2, "flowType");
            return (Criteria) this;
        }

        public Criteria andScenarioFieldIsNull() {
            addCriterion("SCENARIO_FIELD is null");
            return (Criteria) this;
        }

        public Criteria andScenarioFieldIsNotNull() {
            addCriterion("SCENARIO_FIELD is not null");
            return (Criteria) this;
        }

        public Criteria andScenarioFieldEqualTo(String value) {
            addCriterion("SCENARIO_FIELD =", value, "scenarioField");
            return (Criteria) this;
        }

        public Criteria andScenarioFieldNotEqualTo(String value) {
            addCriterion("SCENARIO_FIELD <>", value, "scenarioField");
            return (Criteria) this;
        }

        public Criteria andScenarioFieldGreaterThan(String value) {
            addCriterion("SCENARIO_FIELD >", value, "scenarioField");
            return (Criteria) this;
        }

        public Criteria andScenarioFieldGreaterThanOrEqualTo(String value) {
            addCriterion("SCENARIO_FIELD >=", value, "scenarioField");
            return (Criteria) this;
        }

        public Criteria andScenarioFieldLessThan(String value) {
            addCriterion("SCENARIO_FIELD <", value, "scenarioField");
            return (Criteria) this;
        }

        public Criteria andScenarioFieldLessThanOrEqualTo(String value) {
            addCriterion("SCENARIO_FIELD <=", value, "scenarioField");
            return (Criteria) this;
        }

        public Criteria andScenarioFieldLike(String value) {
            addCriterion("SCENARIO_FIELD like", value, "scenarioField");
            return (Criteria) this;
        }

        public Criteria andScenarioFieldNotLike(String value) {
            addCriterion("SCENARIO_FIELD not like", value, "scenarioField");
            return (Criteria) this;
        }

        public Criteria andScenarioFieldIn(List<String> values) {
            addCriterion("SCENARIO_FIELD in", values, "scenarioField");
            return (Criteria) this;
        }

        public Criteria andScenarioFieldNotIn(List<String> values) {
            addCriterion("SCENARIO_FIELD not in", values, "scenarioField");
            return (Criteria) this;
        }

        public Criteria andScenarioFieldBetween(String value1, String value2) {
            addCriterion("SCENARIO_FIELD between", value1, value2, "scenarioField");
            return (Criteria) this;
        }

        public Criteria andScenarioFieldNotBetween(String value1, String value2) {
            addCriterion("SCENARIO_FIELD not between", value1, value2, "scenarioField");
            return (Criteria) this;
        }

        public Criteria andFlowFieldIsNull() {
            addCriterion("FLOW_FIELD is null");
            return (Criteria) this;
        }

        public Criteria andFlowFieldIsNotNull() {
            addCriterion("FLOW_FIELD is not null");
            return (Criteria) this;
        }

        public Criteria andFlowFieldEqualTo(String value) {
            addCriterion("FLOW_FIELD =", value, "flowField");
            return (Criteria) this;
        }

        public Criteria andFlowFieldNotEqualTo(String value) {
            addCriterion("FLOW_FIELD <>", value, "flowField");
            return (Criteria) this;
        }

        public Criteria andFlowFieldGreaterThan(String value) {
            addCriterion("FLOW_FIELD >", value, "flowField");
            return (Criteria) this;
        }

        public Criteria andFlowFieldGreaterThanOrEqualTo(String value) {
            addCriterion("FLOW_FIELD >=", value, "flowField");
            return (Criteria) this;
        }

        public Criteria andFlowFieldLessThan(String value) {
            addCriterion("FLOW_FIELD <", value, "flowField");
            return (Criteria) this;
        }

        public Criteria andFlowFieldLessThanOrEqualTo(String value) {
            addCriterion("FLOW_FIELD <=", value, "flowField");
            return (Criteria) this;
        }

        public Criteria andFlowFieldLike(String value) {
            addCriterion("FLOW_FIELD like", value, "flowField");
            return (Criteria) this;
        }

        public Criteria andFlowFieldNotLike(String value) {
            addCriterion("FLOW_FIELD not like", value, "flowField");
            return (Criteria) this;
        }

        public Criteria andFlowFieldIn(List<String> values) {
            addCriterion("FLOW_FIELD in", values, "flowField");
            return (Criteria) this;
        }

        public Criteria andFlowFieldNotIn(List<String> values) {
            addCriterion("FLOW_FIELD not in", values, "flowField");
            return (Criteria) this;
        }

        public Criteria andFlowFieldBetween(String value1, String value2) {
            addCriterion("FLOW_FIELD between", value1, value2, "flowField");
            return (Criteria) this;
        }

        public Criteria andFlowFieldNotBetween(String value1, String value2) {
            addCriterion("FLOW_FIELD not between", value1, value2, "flowField");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}